<template>
  <q-page padding>
    <div class="text-h5 q-mb-md">Nuevo Recibo</div>
    <q-banner inline-actions class="text-white bg-red">
      Generacion de RECIBO X, DOCUMENTO NO VALIDO COMO FACTURA
    </q-banner>
    <br />
    <div class="row q-col-gutter-xs">
      <div class="col-12">
        <q-card>
          <q-card-section class="row q-col-gutter-xs q-pa-md">
            <div class="col-md-4 col-xs-12">
              <div class="q-gutter-md">
                <q-select
                  v-model="storeRecibo.form.concepto_id"
                  dense
                  filled
                  emit-value
                  stack-label
                  map-options
                  option-value="id"
                  option-label="nombre"
                  :options="storeRecibo.combos.conceptos"
                  label="conceptos"
                  hide-bottom-space
                  :error="validacion.has('concepto_id')"
                  :error-message="validacion.first('concepto_id')"
                  @update:model-value="storeRecibo.changeConceptoTipo"
                >
                  <template v-slot:prepend>
                    <q-icon name="foundation" />
                  </template>
                </q-select>
                <q-select
                  v-if="storeRecibo.form.concepto_id == 2"
                  v-model="storeRecibo.form.evento_id"
                  @update:model-value="storeRecibo.changeEvento"
                  dense
                  filled
                  emit-value
                  stack-label
                  map-options
                  option-value="id"
                  option-label="nombre"
                  :options="storeRecibo.combos.eventos"
                  label="Evento vinculado"
                  hide-bottom-space
                  :error="validacion.has('evento_id')"
                  :error-message="validacion.first('evento_id')"
                >
                  <template v-slot:prepend>
                    <q-icon name="foundation" />
                  </template>
                </q-select>
              </div>
            </div>
            <!-----------------------------------------------------------------------------------------------------
                  COLUMNA 2
            ----------------------------------------------------------------------------------------------------->
            <div class="col-md-4 col-xs-12">
              <div class="q-gutter-md">
                <q-select
                  v-model="storeRecibo.form.tipo_destinatario"
                  dense
                  filled
                  emit-value
                  stack-label
                  map-options
                  :options="[
                    { label: 'Organismo', value: 'O' },
                    { label: 'Persona', value: 'P' },
                  ]"
                  label="Tipo de destinatario: "
                  hide-bottom-space
                  :error="validacion.has('tipo_destinatario')"
                  :error-message="validacion.first('tipo_destinatario')"
                />

                <selectOrganismos
                  v-if="storeRecibo.form.tipo_destinatario == 'O'"
                  v-model="storeRecibo.form.organismo_by"
                  label="Organismo"
                  :multiple="false"
                />
                <InputBuscar
                  v-if="storeRecibo.form.tipo_destinatario == 'P'"
                  v-model="storeRecibo.form.persona_by"
                />
              </div>
            </div>
            <!-----------------------------------------------------------------------------------------------------
                  COLUMNA 3
            ----------------------------------------------------------------------------------------------------->
            <div class="col-md-4 col-xs-12">
              <div class="q-gutter-md">
                <q-input
                  filled
                  dense
                  label="Fecha"
                  v-model="storeRecibo.form.fecha"
                  mask="date"
                  hide-bottom-space
                  :error="validacion.has('fecha')"
                  :error-message="validacion.first('fecha')"
                >
                  <template v-slot:append>
                    <q-icon name="event" class="cursor-pointer">
                      <q-popup-proxy
                        cover
                        transition-show="scale"
                        transition-hide="scale"
                      >
                        <q-date v-model="storeRecibo.form.fecha">
                          <div class="row items-center justify-end">
                            <q-btn
                              v-close-popup
                              label="Close"
                              color="primary"
                              flat
                            />
                          </div>
                        </q-date>
                      </q-popup-proxy>
                    </q-icon>
                  </template>
                </q-input>

                <div class="row q-col-gutter-xs">
                  <div class="col-md-4 col-xs-12">
                    <!--
                    <q-option-group
                      type="radio"
                      v-model="storeRecibo.form.calculo"
                      :options="[
                        {
                          label: 'Automaticamente',
                          value: 'A',
                          color: 'green',
                        },
                        { label: 'Manual', value: 'M', color: 'red' },
                      ]"
                    />-->

                    <q-toggle
                      v-model="storeRecibo.form.calculo"
                      @update:model-value="storeRecibo.changeCalculo"
                      :label="
                        storeRecibo.form.calculo == 'A'
                          ? 'Automatico'
                          : 'Manual'
                      "
                      color="green"
                      false-value="M"
                      true-value="A"
                      checked-icon="done"
                      unchecked-icon="clear"
                      dense
                      stack-label
                      hide-bottom-space
                    />
                  </div>

                  <div class="col-md-8 col-xs-12">
                    <q-input
                      type="number"
                      v-model="storeRecibo.form.total"
                      label="Suma Recibida"
                      bg-color="green-11"
                      standout
                      mask="######"
                      :disable="storeRecibo.form.calculo == 'A'"
                    >
                      <template v-slot:prepend>
                        <q-icon name="attach_money" />
                      </template>
                    </q-input>
                  </div>
                </div>
              </div>
            </div>
            <div class="col-md-12 col-xs-12">
              <q-input
                label="Observaciones"
                v-model="storeRecibo.form.observaciones"
                type="textarea"
                rows="4"
                filled
              />
            </div>
          </q-card-section>
          <q-card-actions align="right">
            <!-----------------------------------------------------------------------------------------------------
                  BOTON
            ----------------------------------------------------------------------------------------------------->
            <q-btn
              label="Crear Recibo"
              color="green"
              @click="submitCrearRecibo"
            />
            <q-btn
              label="Borrar"
              color="red"
              @click="storeRecibo.reiniciarFormulario()"
            />
          </q-card-actions>
        </q-card>
      </div>
      <div class="col-12" v-if="storeRecibo.form.tipo_destinatario === 'O'">
        <DetalleFormulario />
      </div>
    </div>
    <ModalConfirmacionPartial />
    <Loading :showing="loading" :text="loading_text" />
  </q-page>
</template>

<script lang="ts">
import { defineComponent, ref, onMounted } from 'vue';
import { validacion } from 'src/boot/axios/index';
import Loading from 'src/components/Loading.vue';

import InputBuscar from 'components/Personas/InputBuscar.vue';
import selectOrganismos from 'src/components/Form/selectOrganismos.vue';
import { useUserStore } from 'src/stores/user';
import DetalleFormulario from './_DetallePartial.vue';
import ModalConfirmacionPartial from './_ModalConfirmacionPartial.vue';
import { useReciboNuevoStore } from 'src/stores/finanzas/reciboNuevoStore';
import { useQuasar } from 'quasar';

export default defineComponent({
  name: 'EventosCreacionPage',

  components: {
    Loading,
    selectOrganismos,
    InputBuscar,
    DetalleFormulario,
    ModalConfirmacionPartial,
  },
  setup() {
    const storeUser = useUserStore();
    const $q = useQuasar();

    const storeRecibo = useReciboNuevoStore();
    const loading = ref<boolean>(true);
    const loading_text = ref<string>('Obteniendo Datos');

    onMounted(() => {
      storeRecibo.getCombos().finally(() => {
        loading.value = false;
      });
    });

    function submitCrearRecibo() {
      // Realizo algunas validaciones basicas antes de permitir crear el recibo.

      if (storeRecibo.form.total === 0) {
        // si es de tipo evento, ES OBLIGATORIO definir el evento.
        $q.notify({
          group: true,
          message: 'No se puede crear un recibo en $0',
          type: 'negative',
          position: 'top',
        });
        return;
      }

      if (
        storeRecibo.form.concepto_id === 2 &&
        storeRecibo.form.evento_id === null
      ) {
        // si es de tipo evento, ES OBLIGATORIO definir el evento.
        $q.notify({
          group: true,
          message: 'Debe definir un evento',
          type: 'negative',
          position: 'top',
        });
        return;
      }

      // Si el recibo esta dirigido a un grupo, tiene que tener cargado los nombre de personas.
      if (storeRecibo.form.tipo_destinatario === 'O') {
        if (storeRecibo.form.organismo_by === null) {
          $q.notify({
            group: true,
            message: 'Debe definir un organismo',
            type: 'negative',
            position: 'top',
          });
          return;
        }

        let result = storeRecibo.form.detalles.find(
          (item) => item.persona_uuid === null
        );
        if (result !== undefined) {
          $q.notify({
            group: true,
            message: 'Falta definir el una persona el detalle',
            type: 'negative',
            position: 'top',
          });
          return;
        }
      }

      if (storeRecibo.form.tipo_destinatario === 'P') {
        if (storeRecibo.form.persona_by === null) {
          $q.notify({
            group: true,
            message: 'Debe definir una persona',
            type: 'negative',
            position: 'top',
          });
          return;
        }
      }
      //  storeRecibo.dialog = true;

      storeRecibo.$patch({
        dialog: true,
      });

      //  storeRecibo.submitCrearRecibo();
    }

    return {
      loading,
      loading_text,
      validacion,
      storeRecibo,
      submitCrearRecibo,
      user: storeUser.details,
    };
  },
});
</script>
